#import "MyWindow.h"

@implementation MyWindow

- (id)initWithContentRect:(NSRect)contentRect styleMask:(unsigned int)styleMask backing:(NSBackingStoreType)backingType defer:(BOOL)flag
{
    [super initWithContentRect:contentRect styleMask:styleMask backing:backingType defer:flag];
	
	if ( dataArray == nil ){
		dataArray = [NSMutableArray arrayWithCapacity:1];
		[dataArray retain];
	}
	
//	NSLog (@"InitWithContentRect");
    return self;
}

- (IBAction)showDebtAmountWindowHelp:(id)sender
{
	[amountHelpWindow center];
	[amountHelpWindow makeKeyAndOrderFront: sender];
}

- (IBAction)showInterestRateWindowHelp:(id)sender
{
	[interestRateWindow center];
	[interestRateWindow makeKeyAndOrderFront: sender];
}

- (IBAction)showMonthlyPaymentWindowHelp:(id)sender
{
	[monthlyPaymentWindow center];
	[monthlyPaymentWindow makeKeyAndOrderFront: sender];
}

- (IBAction)showOtherWindowHelp:(id)sender
{
	[otherWindow center];
	[otherWindow makeKeyAndOrderFront: sender];
}

- (IBAction)showSeedMoneyWindowHelp:(id)sender
{
	[seedWindow center];
	[seedWindow makeKeyAndOrderFront: sender];
}

- (IBAction)addLine:(id)sender
{
	    NSMutableDictionary *theNew;
	
	if ([[nameOfDebt stringValue] isEqual : @"Easter Egg"])
        NSRunAlertPanel(@"Boing",@"You paid how much for that Easter Egg?",@"OK",NULL,NULL);
		
	if ([[debtAmount stringValue] isEqual :@""] || [[interestRate stringValue] isEqual :@""] || [[monthlyPayment stringValue] isEqual :@""]){ // and error checking. I probably don't have enough.. oh well.
        NSRunAlertPanel(@"Error",@"I can't make something from nothing.\nPlease enter a debt amount, the interest rate, and the monthly payment!",@"OK",NULL,NULL);
        return;
    }
	
	theNew = [NSMutableDictionary dictionaryWithCapacity: 1];
    [theNew setObject:[nameOfDebt stringValue] forKey:@"nameOfDebt"];
	[nameOfDebt setStringValue:@""]; // this just puts the value in the box back to nothing for the next transaction
    [theNew setObject:[debtAmount stringValue] forKey:@"debtAmount"];
	[debtAmount setStringValue:@""]; // this just puts the value in the box back to nothing for the next transaction
    [theNew setObject:[interestRate stringValue] forKey:@"interestRate"];
	[interestRate setStringValue:@""]; // this just puts the value in the box back to nothing for the next transaction
    [theNew setObject:[monthlyPayment stringValue] forKey:@"monthlyPayment"];
	[monthlyPayment setStringValue:@""]; // this just puts the value in the box back to nothing for the next transaction
    [theNew setObject:[other stringValue] forKey:@"other"];
	[other setStringValue:@""]; // this just puts the value in the box back to nothing for the next transaction
//	NSLog ([theNew description]);
	[dataArray addObject :theNew];
//		NSLog (@"%@", [dataArray description]);
	[table reloadData];
    [table scrollRowToVisible :[dataArray count] - 1];
	
	// place the cursor in the "nameOfDebt" textField, when done...
	// in order for this to work both with return and clicking the button, I had to set the PerformClick action in IB of the last field to the button
	
    [nameOfDebt selectText:self];
	

}

- (IBAction)calulate:(id)sender
{
	NSMutableString *results;
	NSMutableArray *workingArray;
	NSDate *dateTracker;
	int year, month;
	dateTracker = [NSDate date];
	year = [[dateTracker dateWithCalendarFormat: nil timeZone:nil] yearOfCommonEra];
	month = [[dateTracker dateWithCalendarFormat: nil timeZone:nil] monthOfYear];
	workingArray = [NSMutableArray arrayWithCapacity:1];
		results = [NSMutableString stringWithCapacity:50];
	
	int lcv;
	double currentBalance, monthlyInterestRate, thisMonthsInterest, thisMonthsPrincipal, acceleratorAmount;
	int lowestRecord, lowestBalanceAmount;
	
	// yes, it's stupid, but concider this. Trying to populate the "protected" workingArray so as to not disturb dataArray (and thus, be able to compare
	// many times the values put in for the accelerater) with things like arrayWithArray just makes pointers to the original values! So, as you
	// go through messing up workingArray, you are really messing dataArray! AARRGG. So, I make all new values... sigh.
	for ( lcv = 0; lcv < [dataArray count]; lcv++ ){
		NSMutableDictionary *theNew;
		theNew = [NSMutableDictionary dictionaryWithCapacity: 1];
		[theNew setObject:[[dataArray objectAtIndex: lcv] objectForKey: @"nameOfDebt"] forKey:@"nameOfDebt"];
		[theNew setObject:[[dataArray objectAtIndex: lcv] objectForKey: @"debtAmount"] forKey:@"debtAmount"];
		[theNew setObject:[[dataArray objectAtIndex: lcv] objectForKey: @"interestRate"] forKey:@"interestRate"];
		[theNew setObject:[[dataArray objectAtIndex: lcv] objectForKey: @"monthlyPayment"] forKey:@"monthlyPayment"];
		[theNew setObject:[[dataArray objectAtIndex: lcv] objectForKey: @"other"] forKey:@"other"];
		[theNew setObject: @"0" forKey:@"interestPaid"];
		[workingArray addObject :theNew];
		
	}
//	NSLog ([workingArray description]);

	acceleratorAmount = [seedAmount doubleValue];
	while ( [workingArray count] != 0 ){
		lowestRecord = 0;

		lowestBalanceAmount = [[[workingArray objectAtIndex:0] objectForKey :@"debtAmount"] doubleValue];
		for ( lcv = 1; lcv < [workingArray count]; lcv++ ){
			if ([[[workingArray objectAtIndex:lcv] objectForKey :@"debtAmount"] doubleValue] < lowestBalanceAmount ){
				lowestRecord = lcv;
				lowestBalanceAmount = [[[workingArray objectAtIndex:lcv] objectForKey :@"debtAmount"] doubleValue];
			}
		}
		[results appendString: [NSString stringWithFormat: @"The debt you'll pay off next is %@.\nYou'll be adding $%.2f to this bill every month until it's gone.\n\n", [[workingArray objectAtIndex:lowestRecord] objectForKey :@"nameOfDebt"], acceleratorAmount]];
		[results appendString: [NSString stringWithFormat: @"----------------------%d/%d---------------------\n", month, year]];
		while ( [[[workingArray objectAtIndex:lowestRecord] objectForKey :@"debtAmount"] floatValue] > 0 ){
			for ( lcv = 0; lcv < [workingArray count]; lcv++ ){
				currentBalance = [[[workingArray objectAtIndex:lcv] objectForKey :@"debtAmount"] doubleValue];
				monthlyInterestRate = ( [[[workingArray objectAtIndex:lcv] objectForKey :@"interestRate"] doubleValue] / 100 ) / 12;
				thisMonthsInterest = currentBalance * monthlyInterestRate;
				[[workingArray objectAtIndex:lcv] setObject:[NSString stringWithFormat :@"%.2f", [[[workingArray objectAtIndex:lcv] objectForKey :@"interestPaid"] doubleValue] + thisMonthsInterest] forKey:@"interestPaid"];

//				NSLog (@"%f, %f, %f, %f", [[[workingArray objectAtIndex:lcv] objectForKey :@"monthlyPayment"] doubleValue], thisMonthsInterest, [[[workingArray objectAtIndex:lcv] objectForKey :@"other"] doubleValue], acceleratorAmount);
				if ( lcv == lowestRecord )
					thisMonthsPrincipal = [[[workingArray objectAtIndex:lcv] objectForKey :@"monthlyPayment"] doubleValue] - thisMonthsInterest + [[[workingArray objectAtIndex:lcv] objectForKey :@"other"] doubleValue] + acceleratorAmount;
				else
					thisMonthsPrincipal = [[[workingArray objectAtIndex:lcv] objectForKey :@"monthlyPayment"] doubleValue] - thisMonthsInterest + [[[workingArray objectAtIndex:lcv] objectForKey :@"other"] doubleValue];
				[[workingArray objectAtIndex:lcv] setObject:[NSString stringWithFormat :@"%.2f", currentBalance - thisMonthsPrincipal] forKey:@"debtAmount"];

				[results appendString: [NSString stringWithFormat: @"%@: you'll pay $%.2f interest, $%.2f principal and be left with $%@ debt\n", [[workingArray objectAtIndex:lcv] objectForKey :@"nameOfDebt"], thisMonthsInterest, thisMonthsPrincipal, [[workingArray objectAtIndex:lcv] objectForKey :@"debtAmount"]]];

			}
			month++;
			if ( month == 13 ){
				month = 1;
				year++;
			}
			[results appendString: [NSString stringWithFormat: @"----------------------%d/%d---------------------\n", month, year]];
		}
		acceleratorAmount += [[[workingArray objectAtIndex:lowestRecord] objectForKey :@"monthlyPayment"] doubleValue];
		[results appendString: [NSString stringWithFormat: @"%@ is now paid off. \n", [[workingArray objectAtIndex:lowestRecord] objectForKey :@"nameOfDebt"]]];
		[results appendString: [NSString stringWithFormat: @"You paid those fools $%@ in interest. Good riddance to them!\n\n", [[workingArray objectAtIndex:lowestRecord] objectForKey :@"interestPaid"]]];

		if ( [workingArray count] > 1 )
			[results appendString: [NSString stringWithFormat: @"You will now add the monthly payment of $%@ to your accelerator\nand pay off your next debt with an extra $%.2f.\n\n", [[workingArray objectAtIndex:lowestRecord] objectForKey :@"monthlyPayment"] , acceleratorAmount]];

		[workingArray removeObjectAtIndex: lowestRecord];

	}
//	NSLog (results);
	[results appendString: [NSString stringWithFormat: @"\n\nCongratulations! You are now debt free! Don't let it happen again.\nYou now have an extra %.2f every month to play with! Go buy yourself a new iPod!\n\n", acceleratorAmount]];
	[finalResults insertText: results];
	[reportWindow center];
	[reportWindow makeKeyAndOrderFront: sender];
	[results setString: @""];

}

- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
	id theRecord;
//	NSLog (@"%@", 	[aTableColumn identifier]);
    NSParameterAssert(rowIndex >= 0 && rowIndex < [dataArray count]);
    theRecord = [dataArray objectAtIndex:rowIndex];
    return [theRecord objectForKey:[aTableColumn identifier]];

}

- (void)tableView:(NSTableView *)aTableView setObjectValue:anObject forTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
	[[dataArray objectAtIndex:rowIndex] setObject:anObject forKey:[aTableColumn identifier]];
}

- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
//	NSLog (@"%d", [dataArray count]);
	return [dataArray count];
}

- (NSMutableArray *)theData
{
	return dataArray;
}

- (void)setData:(NSMutableArray *)theData
{
	dataArray = [NSMutableArray arrayWithCapacity:1];
	[dataArray addObjectsFromArray: theData];
//	NSLog ([dataArray description]);
	[dataArray retain];
}
- (void)dealloc
{
    [dataArray removeAllObjects];
    [super dealloc];
}

- (NSView *)viewToPrint
{
	return finalResults;
}
@end
